<%@page import="com.xerox.docushare.lifecyclemanager.logs.LifecycleManagerLogs"%>
<%@page import="com.xerox.docushare.amber.util.AmberUtility"%>
<%@page import="com.xerox.docushare.lifecyclemanager.util.Localized"%>
<%@page import="com.xerox.docushare.lifecyclemanager.comparator.DSVectorComparator"%>
<%@ page import="java.sql.*,java.util.*,java.text.*,java.io.*" %>
<%@ page import="com.xerox.docushare.query.*,com.xerox.docushare.object.*,com.xerox.docushare.*"%>
<%@ page import="javax.servlet.http.HttpServletRequest,javax.servlet.http.HttpSession"%>
<%@ page import="com.xerox.docushare.db.jdbc.*,com.xerox.docushare.property.*"%>
<%@page import="com.xerox.docushare.lifecyclemanager.constants.LifecycleManagerConstants"%>
<%@ page import="com.xerox.docushare.lifecyclemanager.util.DSUtils"%> <%-- DS7 AR28447 --%>
<%@ page import="java.util.TreeMap"%> <%-- DS7 AR28447 --%>

<%
String collclass = null;
String selobject = null;
String propstype = null;

Locale requestLocale = Localized.getRequestLocale(request);

StringBuffer sb = new StringBuffer();
boolean namesAdded = false;
String contextRoot = "/" + LifecycleManagerConstants.DS_CONTEXT_ROOT;

HttpSession hs = request.getSession();

DSCredential credential = (DSCredential)hs.getAttribute("dsCredential");
DSServer server = (DSServer)hs.getAttribute("dsServer");
LifecycleManagerLogs.logger.debug("HttpSession: "+hs+" DSCredential: "+credential+" DSServer: "+server);

DSSession dssession = server.createSession(credential);
LifecycleManagerLogs.logger.debug("DSSession: "+dssession);

if(request.getParameter("collclass") != null && request.getParameter("collclass").length() > 0) {
  collclass = request.getParameter("collclass");
}
LifecycleManagerLogs.logger.debug("Selected DSClass: "+collclass);

if(request.getParameter("propstype") != null && request.getParameter("propstype").length() > 0) {
  propstype = request.getParameter("propstype");
}
LifecycleManagerLogs.logger.debug("Props Type: "+propstype);

if(request.getParameter("object") != null && request.getParameter("object").length() > 0) {
  selobject = request.getParameter("object");
}
LifecycleManagerLogs.logger.debug("Selected Object: "+selobject);

if(collclass != null && collclass.length() > 0) {
  if(propstype != null && propstype.equalsIgnoreCase("generalprops")) {
    DSClass dsclass = dssession.getDSClass(collclass);
    DSPropDesc propdesc[] = dsclass.getPropDescs();

    String[] names = new String[propdesc.length+1];
    Vector resultVec = new Vector();

    for(int i=0;i< propdesc.length;i++){
      int propType = propdesc[i].getType();
      String label = null;
      String name = propdesc[i].getName();
      try {
    	  LifecycleManagerLogs.logger.debug("requestLocale " + requestLocale);
        label = propdesc[i].getPropLabel(requestLocale);
        LifecycleManagerLogs.logger.debug("Label from API for " + name + " " + label);
      }
      catch(Exception ex) {
        LifecycleManagerLogs.logger.error("Exception 1 in GetData.jsp for property name : " + name, ex);
        try {
            label = propdesc[i].getPropLabel(Locale.ENGLISH);
          }
          catch(Exception e)
          {
          	    LifecycleManagerLogs.logger.error("Exception 1 GetData.jsp while getting label in English : " + name, ex);
            	label = name;
          };
      }

      if(label.indexOf("&") != -1) {
        label = label.substring(0, label.indexOf("&"))+"and"+label.substring(label.indexOf("&")+1);
      }

      if(propType != DSPropTypes.DATE && propType != DSPropTypes.BOOLEAN && propdesc[i].isSearchable()) { //Edited for AR 26520
        if(!name.equalsIgnoreCase("copiedFrom") && !name.equalsIgnoreCase("max_versions") && !name.equalsIgnoreCase("locale")
        && !name.equalsIgnoreCase("webdav_title") && !name.equalsIgnoreCase("cfSpecialWords") && !name.equalsIgnoreCase("cfCopyID")
        && !name.equalsIgnoreCase("rm_instance_handle") && !name.equalsIgnoreCase("space") && !name.equalsIgnoreCase("abstract")
        && !name.equalsIgnoreCase("routing_template_id") && !name.equalsIgnoreCase("highest_version_used") && !name.equalsIgnoreCase("content_type")
        && !name.equalsIgnoreCase("client_data") && !name.equalsIgnoreCase("content_type") && !name.equalsIgnoreCase("logo")
        && !name.equalsIgnoreCase("spamControl") && !name.equalsIgnoreCase("bg_image") && !name.equalsIgnoreCase("view_format") && !name.equalsIgnoreCase("sort_order"))
        {
          LifecycleManagerLogs.logger.debug("PropName: "+label+" Prop Value: "+name+" Prop Type: "+propType);
          resultVec.addElement(name+"::"+ AmberUtility.escapeValue(label));
        }
      }
    }
    DSVectorComparator propertyComparator = new DSVectorComparator();
    Collections.sort(resultVec, propertyComparator);
    LifecycleManagerLogs.logger.debug("Ordered Collections(Customer): "+resultVec);

    sb.append("<record>");
    for(int i=0;i< resultVec.size();i++){
      sb.append("<GeneralPropertyDetails>"+resultVec.elementAt(i)+"</GeneralPropertyDetails>");
    }
    sb.append("</record>");
    namesAdded = true;
  }
  else {
    DSClass dsclass = dssession.getDSClass(collclass);
    DSPropDesc propdesc[] = dsclass.getPropDescs();

    String[] names = new String[propdesc.length+1];
    Vector resultVec = new Vector();

    for(int i=0;i< propdesc.length;i++){
      int propType = propdesc[i].getType();
      if(propType == DSPropTypes.DATE) {
    	  String label = null;
          String name = propdesc[i].getName();
	      try {
	        label = propdesc[i].getPropLabel(requestLocale);
	      }
	      catch(Exception ex) {
	    	  LifecycleManagerLogs.logger.error("Exception 2 in GetData.jsp for property name : " + name, ex);
	    	  try {
	                label = propdesc[i].getPropLabel(Locale.ENGLISH);
	              }
	              catch(Exception e)
	              {
	              	    LifecycleManagerLogs.logger.error("Exception 2 GetData.jsp while getting label in English : " + name, ex);
	                	label = name;
	              }
	      }
	
	      if(label.indexOf("&") != -1) {
	        label = label.substring(0, label.indexOf("&"))+"and"+label.substring(label.indexOf("&")+1);
	      }

        //if(!name.equalsIgnoreCase("create_date")) {
          LifecycleManagerLogs.logger.debug("Name :"+name+"  Label :"+label);
          resultVec.addElement(name+"::"+AmberUtility.escapeValue(label));
        //}
      }
    }
    DSVectorComparator propertyComparator = new DSVectorComparator();
    Collections.sort(resultVec, propertyComparator);
    LifecycleManagerLogs.logger.debug("Ordered Collections(Customer): "+resultVec);

    sb.append("<record>");
    for(int i=0;i< resultVec.size();i++){
      sb.append("<PropertyDetails>"+resultVec.elementAt(i)+"</PropertyDetails>");
    }
    sb.append("</record>");
    namesAdded = true;
  }
}

if(selobject != null && selobject.length() > 0) {
  DSClass dsclass[] = dssession.getDSClasses();
  Vector resultVec = new Vector();
  // Start :  DS7 AR28447
  TreeMap hm = DSUtils.getDSObjectsMap(dssession);

  String mapKey = selobject;
  String mapValue = (String)hm.get(mapKey);
 if(mapValue != null && !(mapValue.equals(""))) {
    for(int j=0;j< dsclass.length;j++) {
	
	if(mapValue.equals("Discussion"))
	    mapValue = "BulletinBoard";
														  
	if(mapValue.equals("Topic"))
	    mapValue = "Bulletin";
	
      if(dsclass[j].isClonedFrom(dssession.getDSClass(mapValue))) {
        String label = null;
        String name = dsclass[j].getName();
        try {
          label = dsclass[j].getLabel(requestLocale);
        }
        catch(Exception ex)
        {
        	LifecycleManagerLogs.logger.error("Exception 3 in GetData.jsp for property name : " + name, ex);
        	try {
                label = dsclass[j].getLabel(Locale.ENGLISH);
              }
              catch(Exception e)
              {
              	    LifecycleManagerLogs.logger.error("Exception 3 GetData.jsp while getting label in English : " + name, ex);
                	label = name;
              }
        }

        if(label.indexOf("&") != -1) {
          label = label.substring(0, label.indexOf("&"))+"and"+label.substring(label.indexOf("&")+1);
        }

        LifecycleManagerLogs.logger.debug("Name :"+name+"  Label :"+label);
        resultVec.addElement(name+"::"+AmberUtility.escapeValue(label));
      }
    }
    LifecycleManagerLogs.logger.debug("DS objects :"+resultVec);
  }
  else
  {
    LifecycleManagerLogs.logger.debug("DS objects map from DSUtils.getDSObjectsMap() is empty.");
  }
  // End : DS7 AR28447
  DSVectorComparator object_comparator = new DSVectorComparator();
  Collections.sort(resultVec, object_comparator);
  LifecycleManagerLogs.logger.debug("Ordered Collections: "+resultVec);

  sb.append("<record>");
  for(int i=0;i< resultVec.size();i++){
    sb.append("<ObjectDetails>"+resultVec.elementAt(i)+"</ObjectDetails>");
  }
  sb.append("</record>");
  namesAdded = true;
}

if (namesAdded) {
  response.setContentType("text/xml;charset=utf-8");
  response.setHeader("Cache-Control", "no-cache");
  response.setLocale(requestLocale);
  out.write("<records>" + sb.toString() + "</records>");
  LifecycleManagerLogs.logger.debug("getdata: data = " + "<records>" + sb.toString() + "</records>");
}
else {
  response.setStatus(HttpServletResponse.SC_NO_CONTENT);
}
%>
