
<%@page import="com.xerox.docushare.lifecyclemanager.logs.LifecycleManagerLogs"%>
<%@page import="java.text.MessageFormat"%>
<%@page import="com.xerox.docushare.db.DatabaseException"%>
<%@page import="com.xerox.docushare.lifecyclemanager.dbo.DBManager"%>
<%@page import="com.xerox.docushare.lifecyclemanager.util.DSObjectPropertyManager"%>
<%@page import="com.xerox.docushare.object.DSUser"%>
<%@page import="com.xerox.docushare.license.DSLicense"%>
<%@page import="com.xerox.docushare.lifecyclemanager.constants.LifecycleManagerConstants"%>
<%@page import="com.xerox.docushare.lifecyclemanager.util.CollectionManager"%>
<%@page import="com.xerox.docushare.lifecyclemanager.bean.LifeCycleFormBean"%>
<%@page import="java.util.List"%>
<%@page import="com.xerox.docushare.lifecyclemanager.util.PropertyManager"%>
<%@page import="com.xerox.docushare.lifecyclemanager.dbo.AlertReportManager"%>
<%-- DS7 AR26840 --%>       
<%@page import="java.text.DateFormat"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="java.util.Date"%> 
<%-- DS7 AR31863 --%>   
<%@page import="com.xerox.docushare.lifecyclemanager.util.DateUtils"%>

<%@ taglib uri="http://displaytag.sf.net" prefix="display" %>

<%String pageTitle = "Lifecycle Manager Policy Listing";

%>

<%@ include file="Header.jsp" %>
<%
    String title = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.policy_listing_title", currentLocale));
        // Start : DS7 AR26840
	String successMessage = lifeCycleMessageObj.get("lifeCycleManager.LCM_run_successfully", currentLocale); //AR 41302
	String failureMessage = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.LCM_run_failed", currentLocale));
	String disabledPolicyMsg = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.disabled_policy_message", currentLocale)); 
	String expiredPolicyMsg = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.expired_policy_message", currentLocale));
	// End : DS7 AR26840
	//AR33175
	String disabled_label = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.disabled", currentLocale));
	String previewFailureMessage = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.LCM_preview_failed", currentLocale)); // DS7 AR26841
%>



<%
	String status1 = "Lifecycle Manager Policy Listing";
	boolean result = DBManager.getInstance().isTableExist("dsLifecycleManager");
	List<LifeCycleFormBean> repInfoList = null;
	/* AR40726 */
	/*String urlLink = LifecycleManagerConstants.DS_LINK + LifecycleManagerConstants.DS_CONTEXT_ROOT; // DS7 AR26841*/
	String urlLink = LifecycleManagerConstants.DS_CONTEXT_ROOT; 
	if(result){
		repInfoList = AlertReportManager.getInstance().getAlertReportDetails(mDSSession, request);
		LifecycleManagerLogs.logger.debug(" repInfoList.size() " + repInfoList.size());
	}
	request.setAttribute("documentList",repInfoList);
%>
<!DOCTYPE html>
<html>
	<head>
		<title><%=title%></title>
		<%@ include file="cssInclude.jsp" %>
		<link rel="stylesheet" href="css/displaytag_reports.css" type="text/css" />
		
		<style>
			.displayWidth{width:100%;}
		</style>
		<script type="text/javascript" src="<%=base%>javascript/common/js_functions.js"></script>
		<script type="text/javascript"  src="javascript/LoadXMLAjax.js"></script>  <%-- DS7 AR26840 --%>
		<script language="JavaScript" type="">
			function submitForm(id){
				document.reportInfoForm.action = "AddEditLifecycleManagerEvents.jsp";
		
		        document.reportInfoForm.submit();
			}
			// Start : DS7 AR26840
			function runPolicyNow(policyTitle, status, predefinedPolicyStatus){
            var disabledPolicyMsg = "<%= disabledPolicyMsg %>";
			var expiredPolicyMsg = "<%= expiredPolicyMsg %>";
			if(status == "<%= disabled_label %>") //AR33175
			{
			    alert(disabledPolicyMsg);
			}
			else if(predefinedPolicyStatus == "Expired")
			{
			    alert(expiredPolicyMsg);
			}
			else
			{
			    var previewOrRunNow = "RunNow";
				if (policyTitle.indexOf("&") > -1){ //AR37813
					policyTitle = policyTitle.replace(/&/g, "%26");
				}
				if(policyTitle.indexOf("+") > -1){
					policyTitle = policyTitle.replace("+", "%2B");
				}
			    url = "TriggerLCMForThisPolicy.jsp?trigger="+policyTitle+"&previewOrRunNow="+previewOrRunNow;
			    loadXMLDoc(url,"getLCMPolicyRunCallBack","POST");
			    document.getElementById('blackout').style.display = 'block';
			}
			}
			
			function getLCMPolicyRunCallBack(xmlHttp)
			{
				var str = xmlHttp.responseText;
				
				if(!str || str == '') return false;
        
		results = str.split('{SEP}');
		if (!results || results.length<5) return false;  

		var result = results[0].split('=');		   
		var previewOrRunNow = result[1];

		result = results[1].split('=');		   
		var policyTitle = result[1];

		result = results[2].split('=');		   
		var lcmActionResult = result[1];
		
		result = results[3].split('=');		   
		var loginUser = result[1];
		
		result = results[4].split('=');		   
		var ownerEmail = result[1];
				var successMessage = "<%= successMessage %>";
				var failureMessage = "<%= failureMessage %>";
				document.getElementById('blackout').style.display = 'none';
	
				if(lcmActionResult == '')
				  alert(successMessage);
				else
                  alert(failureMessage);	
			}
		        // End : DS7 AR26840
				
			// Start : DS7 AR26841
			function runPolicyPreview(policyTitle, status, predefinedPolicyStatus){
            var disabledPolicyMsg = "<%= disabledPolicyMsg %>";
			var expiredPolicyMsg = "<%= expiredPolicyMsg %>";
			if(status == "<%= disabled_label %>")//AR33175
			{
			    alert(disabledPolicyMsg);
			}
			else if(predefinedPolicyStatus == "Expired")
			{
			    alert(expiredPolicyMsg);
			}
			else
			{
			    var previewOrRunNow = "Preview";
			    if (policyTitle.indexOf("&") > -1){ //AR37813
				policyTitle = policyTitle.replace(/&/g, "%26");
			    }
			    if(policyTitle.indexOf("+") > -1){
				policyTitle = policyTitle.replace("+", "%2B");
			    }
			    url = "TriggerLCMForThisPolicy.jsp?trigger="+policyTitle+"&previewOrRunNow="+previewOrRunNow;
			    loadXMLDoc(url,"getLCMPolicyPreviewCallBack","POST");
			    document.getElementById('blackout').style.display = 'block';
			}
			}
			
			function getLCMPolicyPreviewCallBack(xmlHttp)
			{
				var str = xmlHttp.responseText;

        if(!str || str == '') return false;
        
		results = str.split('{SEP}');
		if (!results || results.length<5) return false;  

		var result = results[0].split('=');		   
		var previewOrRunNow = result[1];

		result = results[1].split('=');		   
		var policyTitle = result[1];

		result = results[2].split('=');		   
		var lcmActionResult = result[1];
		
		result = results[3].split('=');		   
		var loginUser = result[1];
		
		result = results[4].split('=');		   
		var ownerEmail = result[1];
				
				
				var previewFailureMessage = "<%= previewFailureMessage %>";
	            var url = "<%=urlLink%>";
			    document.getElementById('blackout').style.display = 'none';				
				if(lcmActionResult == '')
				{
				  window.location = url +'LifecycleManager/previewResult.jsp?trigger='+policyTitle+'&loginUser='+loginUser+'&ownerEmail='+ownerEmail;
				}
				else
				{
                  alert(previewFailureMessage);
                }				  
			}
			// End : DS7 AR26841	
		</script>
	</head>
	<body>
	<%@ include file="logoHeading.jsp" %>
	<div id="generic_title">
		<h1><%= title %></h1>
	</div>
	<div id="content">
	<form name="reportInfoForm" action="AddEditLifecycleManagerEvents.jsp" target="" method="post">
		<input type="submit" class="bs submit" value="<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.create_event_title", currentLocale)) %>">
		
		      <div class="displayWidth">
		        <div class="displayTag">
		        <% try{
		        		if(repInfoList != null && repInfoList.size() > 0){%>
					          <display:table id="row" name="documentList" defaultsort="8" sort = "list" cellspacing="0" defaultorder="descending" export="true">
					             <%
					             //Set Alert Link
					             int sno 				 			=  ((LifeCycleFormBean)row).getAlertId();
					             String collectionHandle 			=  ((LifeCycleFormBean)row).getCollectionHandle();
					             String policyCreatorHandle 		= ((LifeCycleFormBean)row).getPolicyCreatorHandle();
					             String policyAction 				= ((LifeCycleFormBean)row).getEventNotificationBoth();
					             String datePropertyForEvent		= ((LifeCycleFormBean)row).getPropertyNameToBelookedForInEvent();
					             String datePropertyForNotification	= ((LifeCycleFormBean)row).getPropertyNameToBelookedForInNotification();
					             String objectToSearch 				= ((LifeCycleFormBean)row).getSearchObject();
						     // Start : DS7 AR26843
					             String nextRunDate    = ((LifeCycleFormBean)row).getNextRunDate();
								 String lastRunDate    = ((LifeCycleFormBean)row).getLastRunDate();
								 String lastRunDateToDisplay    = ((LifeCycleFormBean)row).getLastRunDateToDisplay();
						         // End : DS7 AR26843
								 
								 // Start : DS7 AR26840, AR31863
                                 String dateFormat = DateUtils.getDateFormatFromLocaleForJava(currentLocale);
                                 Date presentDate = new Date();
								 String predefinedPolicyStatus 	= ((LifeCycleFormBean)row).getStatus();
								 String endDateObj = "";
								 Date endDate = null;
								 if(predefinedPolicyStatus != null && !(predefinedPolicyStatus.equals("")))
								 {
								     if(predefinedPolicyStatus.startsWith("From"))
								     {
								        endDateObj = (predefinedPolicyStatus.substring(predefinedPolicyStatus.lastIndexOf(":")+1)).trim();
									    SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);
        	                            endDate = sdf.parse(endDateObj);
								     }
								     if(predefinedPolicyStatus.startsWith("From") && presentDate.after(endDate))
								     {
									     predefinedPolicyStatus = "Expired";
								     }
								 }
								 // End : DS7 AR26840, AR31863
					             String propertyLabelforEvent = datePropertyForEvent;
					             String propertyLabelForNotification = datePropertyForNotification;
					             
					             LifecycleManagerLogs.logger.debug("datePropertyForEvent " + datePropertyForEvent);
					             LifecycleManagerLogs.logger.debug("datePropertyForNotification " + datePropertyForNotification);
					             
					            if(datePropertyForEvent != null  && !datePropertyForEvent.equals("")  && !datePropertyForEvent.equals("-1"))
					             	propertyLabelforEvent = DSObjectPropertyManager.getPropertyLabel(dssession, objectToSearch + "." + datePropertyForEvent, request);					             	
					             if(datePropertyForNotification != null  && !datePropertyForNotification.equals("")  && !datePropertyForNotification.equals("-1"))
					            	 propertyLabelForNotification = DSObjectPropertyManager.getPropertyLabel(dssession, objectToSearch + "." + datePropertyForNotification, request);
					             
					             LifecycleManagerLogs.logger.debug("propertyLabelForNotification " + propertyLabelForNotification);
					             LifecycleManagerLogs.logger.debug("propertyLabelforEvent " + propertyLabelforEvent);
					             //DS7 AR26840 : Comment the below code. Added new button for "Edit" option.
					            /* String alertLink = "";
					             if(sno != 0){
					            	 Locale locale = Localized.getRequestLocale(request);// Not sure if this should have been changed or not. dssession.getLocale();
					             	 alertLink = "<a href=\"AddEditLifecycleManagerEvents.jsp?alertId="+sno+"\"><IMG BORDER=\"0\" SRC=\"" 
					             			+ LifecycleManagerConstants.DS_LINK + LifecycleManagerConstants.DS_CONTEXT_ROOT + locale.toString() + "/images/gray-edit.gif\"></a>";
					                 
					             }*/
					
					             //Set collection title
					             String collectionTitle = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.entire_docushare", currentLocale));
					             if(!collectionHandle.trim().equals("") && !collectionHandle.equalsIgnoreCase("all")){
					             	collectionTitle = CollectionManager.getTitle(dssession, collectionHandle, lifeCycleMessageObj, currentLocale);
					             }
					             
					             //Set Policy Owner from the handle
					             String policyOwner = null;
					             
					             DSHandle policyOwnerHandle = new DSHandle(policyCreatorHandle);
		                         DSSelectSet selectSet = new DSSelectSet(new String[] {
		                                 DSUser.classname + "." + DSUser.first_name,
		                                 DSUser.classname + "." + DSUser.last_name});
						//AR34795		
						 String nameArray[] = new String[2];
						 try{
		                                     DSUser policyOwnerUser = (DSUser) dssession.getObject(policyOwnerHandle, selectSet);
						     nameArray[0] = policyOwnerUser.getLastName();
						     nameArray[1] = policyOwnerUser.getFirstName();										 							 
						 } catch(Exception e) {
						     LifecycleManagerLogs.logger.error("PolicyListing.jsp is getting invalid policy owner. ");
						     MessageFormat form = new MessageFormat(MessageDB.get("UserHandleError", currentLocale));
						     nameArray[0] = form.format(new String[]{policyCreatorHandle});
						     nameArray[1] = "";						 
						 }
		                         
		                         policyOwner = AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.personalNameWithFirst", nameArray, currentLocale));
		                        	 		                         
		                         //Get label of search object
		                         String classLabel = DSObjectPropertyManager.getClasslabel(dssession, currentLocale, objectToSearch);
								 String editPageUrl = "AddEditLifecycleManagerEvents.jsp?alertId="+sno; //DS7 AR26840
		                          %>
							
					            <display:column property="policyTitle" sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.title", currentLocale)) %>' class="policy__title" />
					            <display:column sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.collection_title", currentLocale)) %>'>
					            	<%= collectionTitle %>
					            </display:column>
					            <display:column sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.listing_search_object", currentLocale)) %>'>
					            	<%= classLabel %>
					            </display:column>
					            
					            <%if(policyAction.toLowerCase(currentLocale).contains(AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.notification", currentLocale)).toLowerCase(currentLocale))){%>
					            	<display:column sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.date_field", currentLocale)) %>'>
					            		<%= propertyLabelForNotification %>
					            	</display:column>
					            <%}else{%>
					            	<display:column sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.date_field", currentLocale)) %>'>
					            		<%= propertyLabelforEvent %>
					            	</display:column>
					            <%}%>
					            
					            <display:column property="eventNotificationBoth" sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.event_notification_both", currentLocale)) %>'/>
					            
					            <%if(DSUtils.isUserDSAdminUser(dssession, dssession.getLoginPrincipalHandle())){%>
						            <display:column sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.policy_creator_handle", currentLocale)) %>'>
						            	<%= policyOwner %>
						            </display:column>
						        <%}%>
						        
					            <display:column property="status" sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.listing_status", currentLocale)) %>'/>
						    <%-- Start : DS7 AR26843 --%>		
								<display:column property="nextRunDate" sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.next_run_time", currentLocale)) %>'/>
																
								<display:column property="lastRunDateToDisplay" sortable="true" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.last_run_time", currentLocale)) %>'/> 
						  <%-- End : DS7 AR26843 --%>
					            
					            <%-- Start : DS7 AR26840 --%>
                                <%-- <display:column sortable="true" title="" media="html"><%= alertLink %></display:column> --%>
								<display:column sortable="false" title='<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.actions", currentLocale)) %>' media="html"> 								
									<input type="button" class="bs submit-simple" value="<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.edit", currentLocale)) %>" onClick="location.href='<%=editPageUrl%>'"/>									
									<input type="button" class="bs submit-simple" onclick='runPolicyNow("${row.policyTitle}", "${row.status}", "<%=predefinedPolicyStatus%>");' value="<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.run_now", currentLocale)) %>"/>
									<input type="button" class="bs submit-simple" onclick='runPolicyPreview("${row.policyTitle}", "${row.status}", "<%=predefinedPolicyStatus%>");' value="<%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.policy_preview", currentLocale)) %>"/>
								</display:column> 
						        <%-- End : DS7 AR26841 --%>	
					          </display:table>
		          		<%}
		        }
		        catch(Exception ex){
		          LifecycleManagerLogs.logger.error("Exception in PolicyListing.jsp while displaying the report in table: ",ex);
		        }
		        %>
		        </div>
		      </div>
	</form>
</div>
</body>
<!--AR32560-->
	<div id="blackout">
		<div class="transbox">
			<p><br/><br/><%= AmberUtility.escapeValue(lifeCycleMessageObj.get("lifeCycleManager.wait", currentLocale)) %></P>
		</div>
	</div>
<%@ include file="Footer.jsp" %>