<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml" indent="no" encoding="UTF-8"/>

    <xsl:template match="/">
        <xsl:copy>
<!--        
            <xsl:text disable-output-escaping="yes"><![CDATA[<!DOCTYPE  viewdef [
  <!ENTITY nbsp "&#160;">
  <!ENTITY copy "&#169;">
  <!ENTITY shy  "&#173;">
]>]]>
            </xsl:text>
-->            
            <xsl:apply-templates />
        </xsl:copy>
    </xsl:template>
    
    <xsl:template match="a[contains(@href, 'print_email_guide')]" >
    </xsl:template>
    
    <xsl:template match="p" >
        <xsl:variable name="matchNode" select="child::insert[contains(@ref, 'printEmailDesc')]"/>
        <xsl:if test= "not($matchNode)" >
            <xsl:copy-of select="." />
        </xsl:if>
    </xsl:template>
    
    <xsl:template match="comment()[contains(., 'PrintEmail_INSERT')]" >
    </xsl:template>
    
    <xsl:template match="comment()[contains(., 'PrintEmail_Insert')]" >
    </xsl:template>
    
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()" />
        </xsl:copy>
    </xsl:template>

</xsl:stylesheet>
